import iotcloud.*;
import java.util.*;


class WemoController {
    public static void main(String[] args) throws Exception {

        Table t1 = new Table("http://dc-6.calit2.uci.edu/test.iotcloud/", "reallysecret", 351, -1);
        t1.rebuild();

        String a1 = "wemo1";
        String a2 = "wemo2";

        IoTString ia1 = new IoTString(a1);
        IoTString ia2 = new IoTString(a2);


        List<IoTString> keys = new ArrayList<IoTString>();
        keys.add(ia1);
        keys.add(ia2);


        IoTDeviceAddress devAddr1 = new IoTDeviceAddress("192.168.1.16", 49153, 49153, false, false);
        Wemo wemo1 = new Wemo(devAddr1);

        IoTDeviceAddress devAddr2 = new IoTDeviceAddress("192.168.1.34", 49154, 49153, false, false);
        Wemo wemo2 = new Wemo(devAddr2);

        List<Wemo> wemos = new ArrayList<Wemo>();
        wemos.add(wemo1);
        wemos.add(wemo2);


        String pingTimerKey = "wemoController";
        IoTString ipingTimerKey = new IoTString(pingTimerKey);


        String valueA = "on";
        IoTString iValueA = new IoTString(valueA);

        System.out.println("Starting System");
        int counter = 0;


        while (true) {
            try {
                String pingTimer = Long.toString(System.currentTimeMillis());
                IoTString ipingTimer = new IoTString(pingTimer);

                t1.update();
                t1.startTransaction();
                t1.addKV(ipingTimerKey, ipingTimer);
                t1.commitTransaction();


                t1.update();
                Thread.sleep(1000);

                for (int i = 0; i < 2; i++) {
                    IoTString testValA1 = t1.getCommitted(keys.get(i));
                    if ((testValA1 != null) && (testValA1.equals(iValueA) == true)) {
                        wemos.get(i).turnOn();
                    } else {
                        wemos.get(i).turnOff();
                    }
                }

            } catch (Error e) {
                e.printStackTrace();

                Runtime runTime = Runtime.getRuntime();
                runTime.exec("gpio mode 4 out");


                while (true) {
                    runTime.exec("gpio write 4 1");
                    Thread.sleep(500);
                    runTime.exec("gpio write 4 0");
                    Thread.sleep(500);
                }
            }
        }
    }
}